diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/location/TdwgArea_Old.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/location/TdwgArea_Old.java
new file mode 100644
index 0000000000..4a203e27a8
--- /dev/null
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/location/TdwgArea_Old.java
@@ -0,0 +1,236 @@
+/**
+* Copyright (C) 2007 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+
+package eu.etaxonomy.cdm.model.location;
+
+import java.io.IOException;
+import java.io.InputStream;
+import java.util.HashMap;
+import java.util.Map;
+import java.util.UUID;
+
+import javax.persistence.Entity;
+import javax.xml.bind.annotation.XmlAccessType;
+import javax.xml.bind.annotation.XmlAccessorType;
+import javax.xml.bind.annotation.XmlRootElement;
+import javax.xml.bind.annotation.XmlType;
+
+import org.apache.log4j.Logger;
+import org.hibernate.envers.Audited;
+import org.hibernate.search.annotations.Indexed;
+import org.jdom.Element;
+import org.jdom.Namespace;
+
+import eu.etaxonomy.cdm.common.CdmUtils;
+import eu.etaxonomy.cdm.common.XmlHelp;
+import eu.etaxonomy.cdm.model.common.DefaultTermInitializer;
+import eu.etaxonomy.cdm.model.common.Language;
+import eu.etaxonomy.cdm.model.common.Representation;
+import eu.etaxonomy.cdm.model.common.TermVocabulary;
+
+/**
+ * NOTE:
+ * This class is not in use anymore. It will be removed in one of the next versions.
+ * The former class was called <code>TdwgArea</code> 
+ * 
+ * Area terms according to the TDWG GeographicRegion vocabulary
+ * http://rs.tdwg.org/ontology/voc/GeographicRegion.rdf
+ *
+ * @author a.mueller
+ * @created 15.07.2008
+
+ */
+@XmlAccessorType(XmlAccessType.FIELD)
+@XmlType(name = "TdwgArea")
+@XmlRootElement(name = "TdwgArea")
+//@Entity
+@Indexed(index = "eu.etaxonomy.cdm.model.common.DefinedTermBase")
+//@Audited
+@Deprecated
+public class TdwgArea_Old extends NamedArea implements Cloneable{
+    private static final long serialVersionUID = 4662215686356109015L;
+    private static final Logger logger = Logger.getLogger(TdwgArea_Old.class);
+
+//    public static final UUID uuidTdwgAreaVocabulary = UUID.fromString("1fb40504-d1d7-44b0-9731-374fbe6cac77");
+//
+//
+//    private static Map<String, UUID> abbrevMap = null;
+//    private static Map<String, UUID> labelMap = null;
+//
+//    protected static Map<UUID, TdwgArea_Old> termMap = null;
+
+
+
+//************************** METHODS ********************************
+
+//    /* (non-Javadoc)
+//     * @see eu.etaxonomy.cdm.model.common.DefinedTermBase#resetTerms()
+//     */
+//    @Override
+//    public void resetTerms(){
+//        termMap = null;
+//        labelMap = null;
+//        abbrevMap = null;
+//    }
+
+
+//    protected static TdwgArea_Old getTermByUuid(UUID uuid){
+//        if (termMap == null){
+//            DefaultTermInitializer vocabularyStore = new DefaultTermInitializer();
+//            vocabularyStore.initialize();
+//        }
+//        return (TdwgArea_Old)termMap.get(uuid);
+//    }
+
+    /**
+     * FIXME This class should really be refactored into an interface and service implementation,
+     * relying on TermVocabularyDao / service (Ben)
+     * @param tdwgAbbreviation
+     * @return
+     */
+//    public static NamedArea getAreaByTdwgAbbreviation(String tdwgAbbreviation){
+//        if (abbrevMap == null){
+//            initMaps();
+//        }
+//        UUID uuid = abbrevMap.get(tdwgAbbreviation);
+//        if (uuid == null){
+//            logger.info("Unknown TDWG area: " + CdmUtils.Nz(tdwgAbbreviation));
+//            return null;
+//        }
+//        return TdwgArea_Old.getTermByUuid(uuid);
+//    }
+//
+//    /**
+//     * FIXME This class should really be refactored into an interface and service implementation,
+//     * relying on TermVocabularyDao / service (Ben)
+//     * @param tdwgLabel
+//     * @return
+//     */
+//    public static NamedArea getAreaByTdwgLabel(String tdwgLabel){
+//        if (labelMap == null){
+//            initMaps();
+//        }
+//        tdwgLabel = tdwgLabel.toLowerCase();
+//        UUID uuid = labelMap.get(tdwgLabel);
+//        if (uuid == null){
+//            logger.info("Unknown TDWG area: " + CdmUtils.Nz(tdwgLabel));
+//            return null;
+//        }
+//        return TdwgArea_Old.getTermByUuid(uuid);
+//    }
+//
+//    public static boolean isTdwgAreaLabel(String label){
+//        label = (label == null? null : label.toLowerCase());
+//        if (labelMap.containsKey(label)){
+//            return true;
+//        }else{
+//            return false;
+//        }
+//    }
+//
+//    public static boolean isTdwgAreaAbbreviation(String abbrev){
+//        if (abbrevMap.containsKey(abbrev)){
+//            return true;
+//        }else{
+//            return false;
+//        }
+//    }
+
+
+    /* (non-Javadoc)
+     * @see eu.etaxonomy.cdm.model.location.NamedArea#setDefaultTerms(eu.etaxonomy.cdm.model.common.TermVocabulary)
+     */
+//	@Override
+//	protected void setDefaultTerms(TermVocabulary<NamedArea> termVocabulary) {
+//		Set<NamedArea> terms = termVocabulary.getTerms();
+//		for (NamedArea term : terms){
+//			addTdwgArea(term);
+//		}
+//	}
+
+//    @Override
+//    protected void setDefaultTerms(TermVocabulary<NamedArea> termVocabulary) {
+//        termMap = new HashMap<UUID, TdwgArea_Old>();
+//        for (NamedArea term : termVocabulary.getTerms()){
+//            termMap.put(term.getUuid(), (TdwgArea_Old)term);  //TODO casting
+//            addTdwgArea(term);
+//        }
+//    }
+
+
+//    protected static void addTdwgArea(NamedArea area){
+//        if (area == null){
+//            logger.warn("tdwg area is null");
+//            return;
+//        }
+//        Language lang = Language.DEFAULT();
+//        Representation representation = area.getRepresentation(lang);
+//        String tdwgAbbrevLabel = representation.getAbbreviatedLabel();
+//        String tdwgLabel = representation.getLabel().toLowerCase();
+//        if (tdwgAbbrevLabel == null){
+//            logger.warn("tdwgLabel = null");
+//            return;
+//        }
+//        //init map
+//        if (abbrevMap == null){
+//            abbrevMap = new HashMap<String, UUID>();
+//        }
+//        if (labelMap == null){
+//            labelMap = new HashMap<String, UUID>();
+//        }
+//        //add to map
+//        abbrevMap.put(tdwgAbbrevLabel, area.getUuid());
+//        labelMap.put(tdwgLabel, area.getUuid());
+//        //add type
+//        area.setType(NamedAreaType.ADMINISTRATION_AREA());
+//        //add level
+//        if (tdwgAbbrevLabel.trim().length()== 1){
+//            area.setLevel(NamedAreaLevel.TDWG_LEVEL1());
+//        }else if (tdwgAbbrevLabel.trim().length()== 2){
+//            area.setLevel(NamedAreaLevel.TDWG_LEVEL2());
+//        }else if (tdwgAbbrevLabel.trim().length()== 3){
+//            area.setLevel(NamedAreaLevel.TDWG_LEVEL3());
+//        }else if (tdwgAbbrevLabel.trim().length()== 6){
+//            area.setLevel(NamedAreaLevel.TDWG_LEVEL4());
+//        }else {
+//            logger.warn("Unknown TDWG Level " + tdwgAbbrevLabel + "! Unvalid string length (" +  tdwgAbbrevLabel.length() +")");
+//        }
+//    }
+//
+//    private static void initMaps(){
+//        labelMap = new HashMap<String, UUID>();
+//        abbrevMap = new HashMap<String, UUID>();
+//    }
+
+
+//********************* OLD ******************************/
+
+
+//    private static NamedArea getNamedAreaByTdwgLabel(String tdwgLabel){
+//        if (tdwgLabel == null){
+//            return null;
+//        }
+//        InputStream file;
+//        try {
+//            file = CdmUtils.getReadableResourceStream("");
+//        } catch (IOException e) {
+//            logger.error(e);
+//            e.printStackTrace();
+//            return null;
+//        }
+//        Element root = XmlHelp.getRoot(file, "RDF");
+//        Namespace nsRdf = root.getNamespace("rdf");
+//        XmlHelp.getFirstAttributedChild(root, "", "ID", tdwgLabel.trim());
+//
+//        //Filter filter = ;
+//        //root.getDescendants(filter);
+//        return null;
+//    }
+
+}
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/media/IdentifiableMediaEntity.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/media/IdentifiableMediaEntity.java
index 3df2226804..a6121b792c 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/media/IdentifiableMediaEntity.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/media/IdentifiableMediaEntity.java
@@ -40,10 +40,9 @@ import eu.etaxonomy.cdm.strategy.merge.MergeMode;
 @MappedSuperclass
 @Audited
 public abstract class IdentifiableMediaEntity<S extends IIdentifiableEntityCacheStrategy> extends IdentifiableEntity<S> implements IMediaDocumented, IMediaEntity{
-
 	private static final long serialVersionUID = 4038647011021908313L;
-
-	protected static Logger logger = Logger.getLogger(IdentifiableMediaEntity.class);
+	@SuppressWarnings("unused")
+	private static final Logger logger = Logger.getLogger(IdentifiableMediaEntity.class);
 
     @XmlElementWrapper(name = "Media", nillable = true)
     @XmlElement(name = "Medium")
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/media/Media.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/media/Media.java
index 1325546105..1253f5477e 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/media/Media.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/media/Media.java
@@ -366,10 +366,10 @@ public class Media extends IdentifiableEntity<IIdentifiableEntityCacheStrategy>
         this.description.put(description.getLanguage(), description);
     }
 
-    public void addDescription(String text, Language language){
+    public void putDescription(Language language, String text){
         this.description.put(language, LanguageString.NewInstance(text, language));
     }
-
+    
     public void removeDescription(Language language){
         this.description.remove(language);
     }
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/media/Rights.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/media/Rights.java
index a59d59d420..fca256c4ca 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/media/Rights.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/media/Rights.java
@@ -14,6 +14,7 @@ import java.net.URI;
 import javax.persistence.Entity;
 import javax.persistence.FetchType;
 import javax.persistence.ManyToOne;
+import javax.persistence.Table;
 import javax.xml.bind.annotation.XmlAccessType;
 import javax.xml.bind.annotation.XmlAccessorType;
 import javax.xml.bind.annotation.XmlElement;
@@ -53,6 +54,7 @@ import eu.etaxonomy.cdm.model.common.LanguageStringBase;
 @XmlRootElement(name = "Rights")
 @Entity
 @Audited
+@Table(name = "RightsInfo")  //to avoid conflicts with reserved database words
 public class Rights extends LanguageStringBase implements Cloneable{
 	private static final long serialVersionUID = 4920749849951432284L;
 	private static final Logger logger = Logger.getLogger(Rights.class);
@@ -70,7 +72,7 @@ public class Rights extends LanguageStringBase implements Cloneable{
 	@XmlIDREF
 	@XmlSchemaType(name = "IDREF")
 	@ManyToOne(fetch = FetchType.LAZY)
-	private RightsTerm type;
+	private RightsType type;
 
 	// owner etc as defined by the rightstype
 	@XmlElement(name = "Agent")
@@ -112,11 +114,11 @@ public class Rights extends LanguageStringBase implements Cloneable{
 		super(text, language);
 	}
 
-	public RightsTerm getType(){
+	public RightsType getType(){
 		return this.type;
 	}
 
-	public void setType(RightsTerm type){
+	public void setType(RightsType type){
 		this.type = type;
 	}
 
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/media/RightsType.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/media/RightsType.java
new file mode 100644
index 0000000000..93436637d3
--- /dev/null
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/media/RightsType.java
@@ -0,0 +1,126 @@
+/**
+* Copyright (C) 2007 EDIT
+* European Distributed Institute of Taxonomy 
+* http://www.e-taxonomy.eu
+* 
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+
+package eu.etaxonomy.cdm.model.media;
+
+import java.util.HashMap;
+import java.util.Map;
+import java.util.UUID;
+
+import javax.persistence.Entity;
+import javax.xml.bind.annotation.XmlAccessType;
+import javax.xml.bind.annotation.XmlAccessorType;
+import javax.xml.bind.annotation.XmlRootElement;
+import javax.xml.bind.annotation.XmlType;
+
+import org.apache.log4j.Logger;
+import org.hibernate.envers.Audited;
+import org.hibernate.search.annotations.Indexed;
+
+import eu.etaxonomy.cdm.model.common.DefinedTermBase;
+import eu.etaxonomy.cdm.model.common.TermType;
+import eu.etaxonomy.cdm.model.common.TermVocabulary;
+
+/**
+ * @author m.doering
+ * @created 08-Nov-2007 13:06:50
+ */
+@XmlAccessorType(XmlAccessType.FIELD)
+@XmlType(name = "RightsType")
+@XmlRootElement(name = "RightsType")
+@Entity
+@Indexed(index = "eu.etaxonomy.cdm.model.common.DefinedTermBase")
+@Audited
+public class RightsType extends DefinedTermBase<RightsType> {
+	private static final long serialVersionUID = -5823263624000932116L;
+	private static final Logger logger = Logger.getLogger(RightsType.class);
+
+	protected static Map<UUID, RightsType> termMap = null;		
+
+	
+	/**
+	 * Factory method
+	 * @return
+	 */
+	public static RightsType NewInstance(){
+		logger.debug("NewInstance");
+		return new RightsType();
+	}
+
+	/**
+	 * Factory method
+	 * @return
+	 */
+	public static RightsType NewInstance(String text, String label, String labelAbbrev){
+		return new RightsType(text, label, labelAbbrev);
+	}
+	
+//***************** CONSTRUCTOR **************************************/
+	
+	//for javassist only
+	@Deprecated
+	protected RightsType() {
+		super(TermType.RightsType);
+	}
+
+	/**
+	 * Constructor
+	 */
+	private RightsType(String term, String label, String labelAbbrev) {
+		super(TermType.RightsType, term, label, labelAbbrev);
+	}
+
+	
+
+// ************************************* MTEHODS ***************************************************/	
+	
+	/* (non-Javadoc)
+	 * @see eu.etaxonomy.cdm.model.common.DefinedTermBase#resetTerms()
+	 */
+	@Override
+	public void resetTerms(){
+		termMap = null;
+	}
+	
+	protected static RightsType getTermByUuid(UUID uuid){
+		if (termMap == null){
+			return null;  //better return null then initialize the termMap in an unwanted way 
+		}
+		return (RightsType)termMap.get(uuid);
+	}
+	
+	/**
+	 * http://purl.org/dc/terms/accessRights
+	 */
+	public static final RightsType ACCESS_RIGHTS(){
+		return getTermByUuid(uuidAccessRights);
+	}
+
+	public static final RightsType COPYRIGHT(){
+		return getTermByUuid(uuidCopyright);
+	}
+
+	public static final RightsType LICENSE(){
+		return getTermByUuid(uuidLicense);
+	}
+	
+	private static final UUID uuidLicense = UUID.fromString("67c0d47e-8985-1014-8845-c84599f9992c");
+	private static final UUID uuidCopyright = UUID.fromString("d1ef838e-b195-4f28-b8eb-0d3be080bd37");
+	private static final UUID uuidAccessRights = UUID.fromString("a50b4def-b3ac-4508-b50a-e0f249e3a1d7");
+
+
+	@Override
+	protected void setDefaultTerms(TermVocabulary<RightsType> termVocabulary) {
+		termMap = new HashMap<UUID, RightsType>();
+		for (RightsType term : termVocabulary.getTerms()){
+			termMap.put(term.getUuid(), (RightsType)term);
+		}	
+	}
+
+}
\ No newline at end of file
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/metadata/CdmMetaData.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/metadata/CdmMetaData.java
new file mode 100644
index 0000000000..e8229ee2bc
--- /dev/null
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/metadata/CdmMetaData.java
@@ -0,0 +1,241 @@
+// $Id$
+/**
+* Copyright (C) 2007 EDIT
+* European Distributed Institute of Taxonomy 
+* http://www.e-taxonomy.eu
+* 
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+
+package eu.etaxonomy.cdm.model.metadata;
+
+import java.util.ArrayList;
+import java.util.Comparator;
+import java.util.List;
+
+import javax.persistence.Entity;
+
+import org.apache.log4j.Logger;
+import org.joda.time.DateTime;
+
+import eu.etaxonomy.cdm.common.monitor.IProgressMonitor;
+import eu.etaxonomy.cdm.model.common.CdmBase;
+
+/**
+ * @author a.mueller
+ * @created 07.09.2009
+ */
+@Entity
+public class CdmMetaData extends CdmBase{
+	private static final long serialVersionUID = -3033376680593279078L;
+	@SuppressWarnings("unused")
+	private static final Logger logger = Logger.getLogger(CdmMetaData.class);
+
+	/* It is a little bit confusing that this specific information is located in
+	 * a generic class for metadata. Think about moving the schema version 
+	 *  
+	 */
+	/**
+	 * The database schema version number.
+	 * It is recommended to have the first two numbers equal to the CDM Library version number.
+	 * But it is not obligatory as there may be cases when the library number changes but the
+	 * schema version is not changing.
+	 * The third should be incremented if the schema changes in a way that SCHEMA_VALIDATION.UPDATE
+	 * will probably not work or will not be enough to transform old data into new data.
+	 * The fourth number should be incremented when minor schema changes take place that can
+	 * be handled by SCHEMA_VALIDATION.UPDATE
+	 * The last number represents the date of change.
+	 */
+//	private static final String dbSchemaVersion = "3.0.1.0.201104190000";	
+	private static final String dbSchemaVersion = "3.3.0.0.201309240000";	
+	
+	
+
+	/**
+	 * @return a list of default metadata objects 
+	 */
+	public static final List<CdmMetaData> defaultMetaData(){
+		List<CdmMetaData> result = new ArrayList<CdmMetaData>();
+		// schema version
+		result.add(new CdmMetaData(MetaDataPropertyName.DB_SCHEMA_VERSION, dbSchemaVersion));
+		//term version
+		result.add(new CdmMetaData(MetaDataPropertyName.TERMS_VERSION, termsVersion));
+		// database create time
+		result.add(new CdmMetaData(MetaDataPropertyName.DB_CREATE_DATE, new DateTime().toString()));
+		return result;	
+	}
+	
+	/**
+	 * The version number for the terms loaded by the termloader (csv-files)
+	 * It is recommended to have the first two numbers equal to the CDM Library version number.
+	 * 
+	 * But it is not obligatory as there may be cases when the library number changes but the
+	 * schema version is not changing.
+	 * 
+	 * The third should be incremented if the terms change in a way that is not compatible
+	 * to the previous version (e.g. by changing the type of a term)
+	 * 
+	 * The fourth number should be incremented when compatible term changes take place
+	 * (e.g. when new terms were added)
+	 * 
+	 * The last number represents the date of change.
+	 */
+	private static final String termsVersion = "3.3.0.0.201309010000";
+	
+	
+	public enum MetaDataPropertyName{
+		DB_SCHEMA_VERSION,
+		TERMS_VERSION,
+ 		DB_CREATE_DATE,
+		DB_CREATE_NOTE;
+		
+		public String getSqlQuery(){
+			return "SELECT value FROM CdmMetaData WHERE propertyname=" + this.ordinal();
+		}
+	}
+	
+	/* END OF CONFUSION */
+	private MetaDataPropertyName propertyName;
+	private String value;
+
+	
+	/**
+	 * Method to retrieve a CDM Libraries meta data
+	 * @return
+	 */
+	public static final List<CdmMetaData> propertyList(){
+		List<CdmMetaData> result = new ArrayList<CdmMetaData>();
+		result.add(new CdmMetaData(MetaDataPropertyName.DB_SCHEMA_VERSION, dbSchemaVersion));
+		result.add(new CdmMetaData(MetaDataPropertyName.TERMS_VERSION, termsVersion));
+		result.add(new CdmMetaData(MetaDataPropertyName.DB_CREATE_DATE, new DateTime().toString()));
+		return result;
+	}
+
+//********************* Constructor *********************************************/	
+
+	/**
+	 * Simple constructor to be used by Spring
+	 */
+	protected CdmMetaData(){
+		super();
+	}
+
+	public CdmMetaData(MetaDataPropertyName propertyName, String value) {
+		super();
+		this.propertyName = propertyName;
+		this.value = value;
+	}
+
+//****************** instance methods ****************************************/	
+	
+	/**
+	 * @return the propertyName
+	 */
+	public MetaDataPropertyName getPropertyName() {
+		return propertyName;
+	}
+
+	/**
+	 * @param propertyName the propertyName to set
+	 */
+	public void setPropertyName(MetaDataPropertyName propertyName) {
+		this.propertyName = propertyName;
+	}
+
+	/**
+	 * @return the value
+	 */
+	public String getValue() {
+		return value;
+	}
+
+	/**
+	 * @param value the value to set
+	 */
+	public void setValue(String value) {
+		this.value = value;
+	}
+
+//******************** Version comparator **********************************/
+	
+	public static class VersionComparator implements Comparator<String>{
+		Integer depth;
+		IProgressMonitor monitor;
+		
+		public VersionComparator(Integer depth, IProgressMonitor monitor){
+			this.depth = depth;
+			this.monitor = monitor;
+		}
+		
+		/* (non-Javadoc)
+		 * @see java.util.Comparator#compare(java.lang.Object, java.lang.Object)
+		 */
+		public int compare(String version1, String version2) {
+			int result = 0;
+			String[] version1Split = version1.split("\\.");
+			String[] version2Split = version2.split("\\.");
+			
+			if(version1Split.length == 1 || version2Split.length == 1){
+				throwException("Tried to compare version but given Strings don't seem to " +
+						"contain version numbers. version1: " + version1 + ", version2:" + version2); 
+			}
+			
+			if(depth != null && (version1Split.length < depth || version2Split.length < depth )){
+				throwException("Desired depth can not be achieved with the given strings. depth: " + depth  + ", version1: " + version1 + ", version2:" + version2); 
+			}			
+			
+			int length = (depth == null ||version1Split.length < depth) ? version1Split.length : depth;
+			for (int i = 0; i < length; i++){
+				Long version1Part = Long.valueOf(version1Split[i]);
+				Long version2Part = Long.valueOf(version2Split[i]);
+				int partCompare = version1Part.compareTo(version2Part);
+				if (partCompare != 0){
+					return partCompare;
+				}
+			}
+			return result;
+		}
+		
+		private Throwable throwException(String message){
+			RuntimeException exception =  new RuntimeException(message);
+			if (monitor != null){
+				monitor.warning(message, exception);
+			}
+			throw exception;
+		}
+		
+	}
+
+	/**
+	 * Compares two version string. If version1 is higher than version2 a positive result is returned.
+	 * If both are equal 0 is returned, otherwise -1 is returned.
+	 * @see Comparator#compare(Object, Object)
+	 * @param version1
+	 * @param version2
+	 * @param depth
+	 * @param monitor
+	 * @return
+	 */
+	public static int compareVersion(String version1, String version2, Integer depth, IProgressMonitor monitor){
+		VersionComparator versionComparator = new VersionComparator(depth, monitor);
+		return versionComparator.compare(version1, version2);
+	}
+	
+	public static boolean isDbSchemaVersionCompatible(String version){
+		return compareVersion(dbSchemaVersion, version, 3, null) == 0;
+	}
+
+	public static String getDbSchemaVersion() {
+		return dbSchemaVersion;
+	}
+	
+	public static String getTermsVersion() {
+		return termsVersion;
+	}
+
+	public static boolean isTermsVersionCompatible(String version){
+		return compareVersion(termsVersion, version, 3, null) == 0;
+	}
+	
+}
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/metadata/CdmPreference.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/metadata/CdmPreference.java
new file mode 100644
index 0000000000..d63490f877
--- /dev/null
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/metadata/CdmPreference.java
@@ -0,0 +1,180 @@
+// $Id$
+/**
+* Copyright (C) 2007 EDIT
+* European Distributed Institute of Taxonomy 
+* http://www.e-taxonomy.eu
+* 
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+package eu.etaxonomy.cdm.model.metadata;
+
+import java.io.Serializable;
+
+import javax.persistence.Embeddable;
+import javax.persistence.EmbeddedId;
+import javax.persistence.Entity;
+
+import org.hibernate.validator.constraints.Length;
+
+
+/**
+ * This class may hold all prefrences data for a CDM database.
+ * E.g. one may store what the default nomenclatural code is,
+ * or which default formatter (cache strategy) to use for a 
+ * certain class.
+ * The structure represents a triple where the first item 
+ * (subject) defines for which object the given information is valid. 
+ * The second item (predicate) describes the type of information
+ * and the third item (value) represents the actual value.
+ * 
+ *  E.g. for defining a database wide default nomenclatural code
+ *  you may define a triple ("database", "eu.etaxonomy.cdm.model.name.NomenclaturalCode", "ICZN").
+ *  The set of allowed values and semantics for each combination 
+ *  is up to implementing classes.
+ *  The only restrictions we have is the length of the fields and
+ *  the fact that the first two items (subject, predicate) do
+ *  create a unique key.
+ *  
+ *  Size of single fields may be enlarged in future versions. "Value" may
+ *  become a CLOB.
+ * 
+ * @author a.mueller
+ * @created 03.07.2013
+ */
+@Entity
+public final class CdmPreference implements Serializable {
+	private static final long serialVersionUID = 4307599154287181582L;
+
+	
+	public static final CdmPreference NewInstance(PreferenceSubject subject, PreferencePredicate predicate, String value){
+		return new CdmPreference(subject, predicate, value);
+	}
+	
+	public static PrefKey NewKey(PreferenceSubject subject, PreferencePredicate predicate){
+		return new PrefKey(subject, predicate);
+	}
+	
+	@Embeddable
+	public static class PrefKey implements Serializable{
+		private static final long serialVersionUID = 9019957853773606194L;
+
+		@Length(max=100)  //for now we keep the combined key short as indizes for such keys are very limited in size in some DBMS. Size may be increased later
+		private String subject;
+		
+		@Length(max=100)  //for now we keep the combined key short as indizes for such keys are very limited in size in some DBMS. Size may be increased later
+		private String predicate;
+		
+		//for hibernate use only
+		private PrefKey(){}
+		
+
+		private PrefKey(PreferenceSubject subject, PreferencePredicate predicate){
+			this(subject.getKey(), predicate.getKey());
+		}
+		
+		private PrefKey(String subject, String predicate){
+			if (subject == null) throw new IllegalArgumentException("Subject must not be null for preference");
+			if (predicate == null) throw new IllegalArgumentException("Predicate must not be null for preference");
+			if (subject.length() > 255) throw new IllegalArgumentException("Subject must not be longer then 255 for preference");
+			if (predicate.length() > 255) throw new IllegalArgumentException("Predicate must not be longer then 255 for preference");
+			
+			this.subject = subject;
+			this.predicate = predicate;
+		}
+
+		@Override
+		public int hashCode() {
+			final int prime = 31;
+			int result = 1;
+			result = prime * result + ((predicate == null) ? 0 : predicate.hashCode());
+			result = prime * result	+ ((subject == null) ? 0 : subject.hashCode());
+			return result;
+		}
+
+		@Override
+		public boolean equals(Object obj) {
+			if (this == obj){
+				return true;
+			} else if (obj == null){
+				return false;
+			}else if (getClass() != obj.getClass()){
+				return false;
+			}else{
+				PrefKey other = (PrefKey) obj;
+				return ( predicate.equals(other.predicate) && subject.equals(other.subject));
+			}
+		} 
+	
+	}
+	
+	@EmbeddedId
+	private PrefKey key;
+	
+	@Length(max=1023)
+	private String value;
+	
+//****************** CONSTRUCTOR **********************/	
+	
+	//for hibernate use only
+	@SuppressWarnings("unused")
+	private CdmPreference(){};
+
+	
+	/**
+	 * Constructor.
+	 * @param subject must not be null and must not be longer then 255 characters.
+	 * @param predicate must not be null and must not be longer then 255 characters.
+	 * @param value must not be longer then 1023 characters.
+	 */
+	public CdmPreference(PreferenceSubject subject, PreferencePredicate predicate, String value){
+		this.key = new PrefKey(subject, predicate);
+		//TODO are null values allowed?		assert predicate != null : "value must not be null for preference";
+		if (value != null && value.length() > 1023) {throw new IllegalArgumentException(
+				String.format("value must not be longer then 1023 characters for preference. Value = %s", value));
+		}
+		this.value = value;
+	}
+
+	
+	/**
+	 * Constructor.
+	 * @param subject must not be null and must not be longer then 255 characters.
+	 * @param predicate must not be null and must not be longer then 255 characters.
+	 * @param value must not be longer then 1023 characters.
+	 */
+	public CdmPreference(String subject, String predicate, String value){
+		this.key = new PrefKey(subject, predicate);
+		//TODO are null values allowed?		assert predicate != null : "value must not be null for preference";
+		if (value != null && value.length() > 1023) {throw new IllegalArgumentException(
+			String.format("value must not be longer then 1023 characters for preference. Value = %s", value));
+		}
+		this.value = value;
+
+	}
+
+//************************ GETTER / SETTER ***************************/	
+	
+	public String getSubject() {
+		return key.subject;
+	}
+	
+	public String getPredicate() {
+		return key.predicate;
+	}
+
+	public String getValue() {
+		return value;
+	}
+
+	public PrefKey getKey() {
+		return key;
+	}
+//
+//	we try to avoid setting of values
+//	public void setValue(String value) {
+//		this.value = value;
+//	}
+	
+	
+}
